from django.core.management import BaseCommand
from branch.models import StartupMember
from mentorship.models import MentorshipRequest
from mentorship.views import view_notes_goals_dict
import pprint

pp = pprint.PrettyPrinter()


class Command(BaseCommand):
    """ python3 manage.py print_notes_goals_dict <mentor_urlname> <mentee_urlname>

    Will pretty print out the notes_dict as generated by view function mentorship.views.view_notes()
    for the mentee, but will filter by the specified mentor """

    def add_arguments(self, parser):
        parser.add_argument('mentor_urlname')
        parser.add_argument('mentee_urlname')

    @staticmethod
    def process_note(note):
        pp.pprint(note)

    @staticmethod
    def process_goal(goal):
        print('Item is a goal')


    @staticmethod
    def process_mentor(mentor):
        for item in mentor['data']:
            if item['is_note']:
                Command.process_note(item)
            else:
                pass

    def handle(self, *args, **options):
        mentor_urlname = options['mentor_urlname']
        mentee_urlname = options['mentee_urlname']

        mentee = StartupMember.objects.get(url_name=mentee_urlname)
        print('Mentee: ' + str(mentee))
        mentee_id = mentee.user.id

        # Simulates the same query and view_notes_goals_dict call made by mentorship.views.view_notes()
        mentorship_reqs = MentorshipRequest.objects \
            .select_related('requested_mentorship',
                            'requested_mentorship__student',
                            'requested_mentorship__mentor__profile') \
            .filter(requested_mentorship__student__user_id=mentee_id,
                    is_admin_accepted=True) \
            .order_by('requested_mentorship__mentor__profile__first_name')

        notes_dict = view_notes_goals_dict(mentorship_reqs)

        mentors = notes_dict

        for mentor in mentors:
            if mentor['mentor_url_name'] == mentor_urlname:
                Command.process_mentor(mentor)
